/*
 *  Searching/Query.cs
 *  Copyright (C) 2006-2007 Marcin Krystian Krzywonos
 *  License: GNU/GPL version 2
 */


using System;
using System.Collections;
using System.Xml;
using Incollector.Engine;


namespace Incollector.Searching {
	
	public abstract class Query {
		
		public abstract string ID {
			get ;
		}
		
		public abstract string Name {
			get ;
		}
		
		public abstract Gtk.Widget QueryWidget {
			get ;
		}

		
		public abstract Query New        ();
		public abstract Query Clone      ();
		public abstract bool  CheckQuery (Engine.Entry entry);
		public abstract Query ReadXml    (XmlTextReader reader);
		public abstract void  WriteXml   (XmlTextWriter writer);
	}
}
